]> git.pld-linux.org Git - packages/mysql.git/blame_incremental - mysql.init
- up to 5.5.28
[packages/mysql.git] / mysql.init
... / ...
CommitLineData
1#!/bin/sh
2#
3# mysql A very fast and reliable SQL database engine
4#
5# chkconfig: 2345 84 25
6#
7# description: A very fast and reliable SQL database engine.
8
9# Source function library
10. /etc/rc.d/init.d/functions
11
12# Get network config
13. /etc/sysconfig/network
14
15# Get service config
16if [ -f /etc/sysconfig/mysql ]; then
17 . /etc/sysconfig/mysql
18else
19 nls "Error: %s not found" /etc/sysconfig/mysql
20 nls "%s can't be run." MySQL
21 exit 1
22fi
23
24if [ -n "$MYSQL_DB_CLUSTERS" ]; then
25 nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
26fi
27
28if [ -f /etc/mysql/clusters.conf ]; then
29 MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/ && /=/{print $2}' /etc/mysql/clusters.conf)
30 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
31 nls "Warning: there are no configured clusters."
32 fi
33
34else
35 nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
36 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
37 nls "Warning: there are no configured clusters."
38 nls "Using default cluster /var/lib/mysql (compatibility mode)"
39 MYSQL_DB_CLUSTERS=/var/lib/mysql
40 fi
41fi
42
43
44# Check that networking is up
45if is_yes "${NETWORKING}"; then
46 if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
47 msg_network_down MySQL
48 exit 1
49 fi
50else
51 exit 0
52fi
53
54action="$1"
55
56# any db cluster as command line argument?
57if [ $# -gt 1 ]; then
58 shift
59 # perform action for specified clusters only
60 for a in "$@"; do
61 # try auto resolving from /etc/mysql/clusters.conf
62 if [[ "$a" != /* ]]; then
63 m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
64 if [ -z "$m" ]; then
65 echo >&2 "Cluster name '$a' did not match anything!"
66 exit 1
67 fi
68 if [ $(echo "$m" | wc -l) -gt 1 ]; then
69 echo >&2 "Cluster name '$a' ambiguous:" $m
70 exit 1
71 fi
72 a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
73 fi
74 DB_CLUSTERS="$DB_CLUSTERS $a"
75 done
76else
77 DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
78fi
79
80# global error log, if mysqld.conf hasn't migrated to log-error style
81MYSQL_ERRLOG=/var/log/mysql/mysqld.log
82MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
83
84#
85# Useful functions.
86#
87
88#
89# check for mysql status
90#
91# arguments:
92# $1 - db cluster
93# $2 - start|stop
94#
95# sets variables:
96# MYSQL_STATUS = starting | running | not running | died
97# MYSQL_PID = pid of mysqld process
98#
99mysqlstatus() {
100 clusterdir="$1"
101 mode="$2"
102
103 mysqlgetconfig "$clusterdir" status
104
105 MYSQL_STATUS="not running"
106 MYSQL_PID="unknown"
107 MYSQL_PIDFILE_PID=""
108 MYSQL_GREP_PID=""
109
110 if [ -f "$MYSQL_PIDFILE" ]; then
111 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
112 fi
113
114 if [ -n "$MYSQL_PIDFILE_PID" ]; then
115 MYSQL_PID=$MYSQL_PIDFILE_PID
116 if [ ! -d "/proc/$MYSQL_PID" ]; then
117 MYSQL_STATUS="died"
118 return
119 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
120 MYSQL_STATUS="running"
121 return
122 fi
123 fi
124
125 if [ "$mode" = "start" ]; then
126 MYSQL_GREP_PID=$(grep -lE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
127 if [ -n "$MYSQL_GREP_PID" ]; then
128 MYSQL_PID=$MYSQL_GREP_PID
129 if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
130 if [ -f "$MYSQL_PIDFILE" ]; then
131 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
132 fi
133 if [ -n "$MYSQL_PIDFILE_PID" ]; then
134 MYSQL_PID=$MYSQL_PIDFILE_PID
135 MYSQL_STATUS="running"
136 return
137 else
138 MYSQL_STATUS="starting"
139 return
140 fi
141 fi
142 fi
143 fi
144
145 # else default, "not running"
146}
147
148# get mysql configuration in variables
149# MYSQL_CONFIG MYSQL_CLUSTER_DIR
150# MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
151#
152# arguments
153# $1 - db cluster
154# $2 - status | other
155
156mysqlgetconfig() {
157 local clusterdir="$1" config_file
158 local mode="$2"
159
160 # emulate old behaviour if only one cluster specified
161 if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
162 MYSQL_RA_COMPAT=yes
163 config_file=/etc/mysqld.conf
164 else
165 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
166 if [[ $config = /* ]]; then
167 config_file="$config"
168 elif [ -f "/etc/mysql/$config" ]; then
169 config_file="/etc/mysql/$config"
170 else
171 config_file="$clusterdir/mysqld.conf"
172 fi
173 fi
174
175 MYSQL_CLUSTER_DIR="$clusterdir"
176
177 if [ -z "$config_file" ]; then
178 nls "Error: Can't find config file for %s cluster" "$clusterdir"
179 if [ "$mode" = "status" ]; then
180 exit 3
181 else
182 exit 6
183 fi
184 else
185 MYSQL_CONFIG="$config_file"
186 fi
187
188 if [ ! -f "$config_file" ]; then
189 nls "Error: config file %s not found" "$config_file"
190 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
191 if [ "$mode" = "status" ]; then
192 exit 3
193 else
194 exit 6
195 fi
196 fi
197
198 # reset to initial state
199 MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
200
201 eval `awk -F= '
202 {
203 # undos
204 gsub(/\r$/, "");
205
206 # trim spaces
207 gsub(/^[\t ]+|[\t ]+$/, "", $1);
208 gsub(/^[\t ]+|[\t ]+$/, "", $2);
209 }
210
211 # skip comments and empty lines
212 /^[;#]|^ *$/ { next }
213
214 /^[ \t]*\[.*\][ \t]*$/ {
215 match($0, /\[.*\]/);
216 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
217 next;
218 }
219
220 section == "mysqld" {
221 if ($1 == "datadir") {
222 printf("MYSQL_DATA_DIR=%s;", $2);
223 } else if ($1 == "user") {
224 printf("MYSQL_USER=%s;", $2);
225 } else if ($1 == "pid-file") {
226 printf("MYSQL_PIDFILE=%s;", $2);
227 } else if ($1 == "socket") {
228 printf("MYSQL_SOCKET=%s;", $2);
229 } else if ($1 == "port") {
230 printf("MYSQL_PORT=%s;", $2);
231 } else if ($1 == "bind-address") {
232 printf("MYSQL_BIND_ADDRESS=%s;", $2);
233 } else if ($1 == "skip-networking") {
234 printf("MYSQL_SKIP_NETWORKING=1;");
235 } else if ($1 == "log-error") {
236 printf("MYSQL_LOG_ERROR=%s;", $2);
237 }
238 }
239 ' $config_file`
240
241 # error log not defined in config file. add one
242 if [ -z "$MYSQL_LOG_ERROR" ]; then
243 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
244 else
245 # unset, so mysqld would use value from config itself
246 unset MYSQL_LOG_ERROR
247 fi
248
249 if is_yes "$MYSQL_RA_COMPAT"; then
250 MYSQL_DATA_DIR_SUB=""
251 else
252 MYSQL_DATA_DIR_SUB="/mysqldb"
253 fi
254
255 if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
256 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
257 nls " MySQL can't be run."
258 exit 6
259 fi
260
261 if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
262 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
263 nls " MySQL can't be run."
264 exit 6
265 fi
266
267 if [ -z "$MYSQL_USER" ]; then
268 echo "$(nls 'MySQL user not configured properly')"'!' >&2
269 nls "Edit %s and configure it." "$config_file" >&2
270 exit 6
271 fi
272}
273
274# start mysql
275mysqlstart() {
276 local clusterdir="$1"
277 mysqlgetconfig "$clusterdir"
278 if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
279 nls "MySQL cluster %s not initialized." "$clusterdir"
280 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
281 exit 6
282 fi
283
284 msg_starting "MySQL $clusterdir"; busy
285 [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
286 rm -f "$MYSQL_PIDFILE"
287
288
289 TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
290 /usr/bin/setsid /usr/sbin/mysqld \
291 --defaults-file=$MYSQL_CONFIG \
292 --datadir=$MYSQL_DATA_DIR \
293 --pid-file=$MYSQL_PIDFILE \
294 ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
295 $MYSQL_OPTIONS &
296 pid=$!
297
298 sleep 0.1
299 mysqlstatus "$clusterdir" start
300 # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
301 if [ "$MYSQL_STATUS" = "starting" ]; then
302 echo ""
303 show "Waiting for MySQL to start"
304 busy
305
306 # while the pid is running, mysql is starting up
307 # if the pidfile was created, it started up successfully
308 # if either case fails we break and report status
309 while true; do
310 [ -d /proc/$pid ] || break
311 [ -f "$MYSQL_PIDFILE" ] && break
312 sleep 0.2
313 done
314 fi
315
316 mysqlstatus "$clusterdir" start
317 if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
318 ok
319 elif [ "$MYSQL_STATUS" = "died" ]; then
320 RETVAL=1
321 died
322 else
323 RETVAL=1
324 fail
325 fi
326}
327
328# stop mysql
329mysqlstop() {
330 local clusterdir="$1"
331 mysqlstatus "$clusterdir" stop
332 msg_stopping "MySQL $clusterdir"
333 busy
334
335 # try graceful shutdown -- send shutdown command
336 # requires mysql_sysadmin user proper privs
337 /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
338 mysqlstatus "$clusterdir" stop
339
340 if [ "$MYSQL_PID" != "unknown" ]; then
341 kill -TERM "$MYSQL_PID" 2> /dev/null
342 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
343 [ -d "/proc/$MYSQL_PID" ] || break
344 sleep 0.1
345 done
346 fi
347
348 mysqlstatus "$clusterdir" stop
349 if [ "$MYSQL_STATUS" = "died" ]; then
350 died
351 elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
352 fail
353 else
354 ok
355 fi
356}
357
358# report slave status
359# uses MYSQL_SOCKET - path to mysql socket
360slave_status() {
361 # see if slave status can be reported
362 local err=0 slave_status=$(mysql -S $MYSQL_SOCKET -e 'show slave status\G')
363 if [ -z "$slave_status" ]; then
364 # slave not setup
365 return
366 fi
367
368 printf "\tSlave Status:\n"
369
370 eval $(echo "$slave_status" | awk -F': ' '/^ *[A-Za-z_]+:/{
371 k = tolower($1);
372 v = substr($0, length($1) + 3);
373 gsub(/\\/, "\\\\\\", v);
374 gsub(/"/, "\\\"", v);
375 gsub(/`/, "\\`", v);
376 gsub(/\$/, "\\$", v);
377 printf("%s=\"%s\";\n", k, v);
378 }')
379
380 if [ "$slave_io_running" != "Yes" ]; then
381 printf "\tSlave IO not running\n"
382 err=1
383 fi
384 if [ "$slave_sql_running" != "Yes" ]; then
385 printf "\tSlave SQL not running\n"
386 err=1
387 fi
388
389 if [ "$err" = 1 -a "$last_errno" -gt 0 ]; then
390 printf "\tERROR $last_errno: $last_error\n"
391 fi
392
393 if [ "$master_log_file" != "$relay_master_log_file" ]; then
394 printf "\tERROR logfile mismatch ($relay_master_log_file)\n"
395 err=1
396 fi
397
398 if [ -z "$read_master_log_pos" -o -z "$exec_master_log_pos" ]; then
399 printf "\tERROR No info about master\n"
400 err=1
401 return
402 fi
403
404 diff=$(($read_master_log_pos - $exec_master_log_pos))
405 printf "\tread pos: $read_master_log_pos ($master_log_file) (host: $master_host:$master_port)\n"
406 printf "\texec pos: $exec_master_log_pos\n"
407 printf "\tdiff: $diff\n"
408}
409
410#
411# check for running mysql instances; if any instance is running then
412# create subsys lock file
413#
414mysqlsubsys() {
415 # check for every defined db cluster in sysconfig file
416 for mysqldir in $DB_CLUSTERS; do
417 mysqlstatus "$mysqldir"
418 if [ "$MYSQL_STATUS" = "running" ]; then
419 touch /var/lock/subsys/mysql
420 return
421 fi
422 done
423 rm -f /var/lock/subsys/mysql
424}
425
426mysqlinit() {
427 local clusterdir="$1"
428
429 if [ -f /etc/mysqld.conf ]; then
430 nls "Running in \`no cluster compat' mode: can't initialize database."
431 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
432 exit 1
433 fi
434
435 if [ -f "$clusterdir/mysqld.conf" ]; then
436 mysqlgetconfig "$clusterdir"
437 else
438 MYSQL_USER="mysql"
439 MYSQL_CLUSTER_DIR="$clusterdir"
440 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
441 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
442 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
443
444 # this $MYSQL_CONFIG will be created later
445 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
446 fi
447
448 show "Initializing cluster %s" "$clusterdir"; started
449
450 # Check if not exist init database
451 if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
452 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
453 nls "before initializing database."
454 nls "For now skipping cluster %s." "$clusterdir"
455 return
456 fi
457
458 show "Installing MySQL system tables for $MYSQL_DATA_DIR"
459 busy
460 TMP=/tmp TMPDIR=/tmp
461
462 mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
463 # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
464 chown root:root "$MYSQL_CLUSTER_DIR"
465 chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
466 chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
467
468 if [ -f /usr/share/mysql/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
469 sed -e "
470 s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
471 s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
472 s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
473 s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
474 " /usr/share/mysql/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
475 chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
476 chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
477 fi
478
479 if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
480 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
481 ln -s "$sock" /var/lib/mysql/mysql.sock
482 fi
483
484 cat > $MYSQL_DATA_DIR/mysql-init.sql <<-EOF
485 CREATE DATABASE mysql;
486 use mysql;
487 $(cat /usr/share/mysql/mysql_system_tables.sql)
488 $(sed -e "/@current_hostname/d" /usr/share/mysql/mysql_system_tables_data.sql)
489EOF
490
491 ok=0
492 /usr/sbin/mysqld \
493 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
494 --bootstrap \
495 --skip-grant-tables \
496 --datadir=$MYSQL_DATA_DIR \
497 --user=$MYSQL_USER \
498 --slave-load-tmpdir=$MYSQL_DATA_DIR \
499 --tmpdir=$MYSQL_DATA_DIR \
500 --log-error=$MYSQL_ERRLOG \
501 < $MYSQL_DATA_DIR/mysql-init.sql && ok=1
502 [ -f $MYSQL_DATA_DIR/mysql/host.frm ] || ok=0
503
504 if [ "$ok" = 1 ]; then
505 rm -f $MYSQL_DATA_DIR/mysql-init.sql
506 ok
507 cat << END_OF_MSG
508
509PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
510This is done, after starting database, in the order shown,
511with:
512
513For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
514echo "update mysql.user set password=password('newpassword') where user='mysql_sysadmin'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
515
516For 'mysql' user (ALL privileges, DB admin):
517echo "update mysql.user set password=password('newpassword') where user='mysql'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
518
519NOTE: mysql_sysadmin password should be placed to $MYSQL_CONFIG in
520mysqladmin section. See the manual for more instructions.
521(This user is used at logs rotation and server shutdown)
522
523END_OF_MSG
524 show "Filling help tables..."
525 ok=0
526 ( echo "use mysql;"; cat /usr/share/mysql/fill_help_tables.sql ) | \
527 /usr/sbin/mysqld \
528 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
529 --bootstrap \
530 --skip-grant-tables \
531 --datadir=$MYSQL_DATA_DIR \
532 --user=$MYSQL_USER \
533 --slave-load-tmpdir=$MYSQL_DATA_DIR \
534 --tmpdir=$MYSQL_DATA_DIR \
535 --log-error=$MYSQL_ERRLOG \
536 && ok=1
537 if [ "$ok" = 1 ]; then
538 ok
539 else
540 cat << END_OF_MSG
541
542WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!
543The "HELP" command might not work properly.
544
545END_OF_MSG
546 fi
547 else
548 fail
549 cat << END_OF_MSG
550Installation of grant tables FAILED!
551
552The initialization SQL script was preserved at $MYSQL_DATA_DIR/mysql-init.sql
553
554Examine the logs in /var/log/mysql for more information. You can
555also try to start the mysqld daemon with:
556
557/usr/sbin/mysqld --skip-grant &
558
559You can use the command line tool mysql to connect to the mysql
560database and look at the grant tables:
561
562shell> mysql -u mysql mysql
563mysql> show tables
564
565Try 'mysqld --help' if you have problems with paths. Setting on
566logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
567may be helpful. The latest information about MySQL is available on the
568web at http://www.mysql.com/.
569
570Please check PLD Linux ftp site for newer versions of this package.
571
572Please consult the MySQL manual section: 'Problems running
573mysql_install_db', and the manual section that describes problems on
574your OS. Another information source is the MySQL email archive.
575
576END_OF_MSG
577 exit 1
578 fi
579}
580
581#
582# End of useful functions.
583#
584
585start() {
586 local mysqldir
587 for mysqldir in $DB_CLUSTERS; do
588 mysqlstatus "$mysqldir" start
589 if [ "$MYSQL_STATUS" = "running" ]; then
590 msg_already_running "MySQL $mysqldir"
591 else
592 mysqlstart "$mysqldir"
593 fi
594 done
595 mysqlsubsys
596}
597
598stop() {
599 local mysqldir
600 for mysqldir in $DB_CLUSTERS; do
601 mysqlstatus "$mysqldir" stop
602 if [ "$MYSQL_STATUS" = "not running" ]; then
603 msg_not_running "MySQL $mysqldir"
604 else
605 mysqlstop "$mysqldir"
606 fi
607 done
608 mysqlsubsys
609}
610
611condrestart() {
612 if [ ! -f /var/lock/subsys/mysql ]; then
613 msg_not_running "MySQL"
614 RETVAL=$1
615 return
616 fi
617
618 stop
619 start
620}
621
622RETVAL=0
623case "$action" in
624 start)
625 start
626 ;;
627 stop)
628 stop
629 ;;
630 restart)
631 stop
632 start
633 ;;
634 try-restart)
635 condrestart 0
636 ;;
637 force-reload)
638 condrestart 7
639 ;;
640 init)
641 for mysqldir in $DB_CLUSTERS; do
642 mysqlinit "$mysqldir"
643 done
644 exit $?
645 ;;
646 flush-logs)
647 for mysqldir in $DB_CLUSTERS; do
648 mysqlgetconfig "$mysqldir"
649 # just if mysqld is really running
650 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
651 /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
652 fi
653 done
654 ;;
655 status)
656 RETVAL=3
657 for mysqldir in $DB_CLUSTERS; do
658 mysqlstatus "$mysqldir"
659 if [ "$MYSQL_STATUS" = "running" ]; then
660 RETVAL=0
661 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
662 port=${MYSQL_PORT:-3306}
663 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
664 pid=$MYSQL_PID
665 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
666 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
667 nls "\tunix: %s\n" "$socket"
668
669 MYSQL_SOCKET=$socket slave_status
670
671 pids="$pids/$MYSQL_PID/"
672 progress "$MYSQL_STATUS"
673 else
674 show "MySQL cluster %s" "$mysqldir"
675 progress "$MYSQL_STATUS" "$CFAIL"
676 fi
677 echo
678 done
679
680 for pid in $(/sbin/pidof mysqld); do
681 if [[ $pids != */$pid/* ]]; then
682 running="$running $pid"
683 fi
684 done
685
686 if [ $# = 1 -a "$running" ]; then
687 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
688 # see if we can display their status
689 for pid in $running; do
690 datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
691 datadir=${datadir#--datadir=} # strip --datadir
692 mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
693 mysqlstatus "$mysqldir"
694 if [ "$MYSQL_STATUS" = "running" ]; then
695 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
696 port=${MYSQL_PORT:-3306}
697 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
698 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
699 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
700 nls "\tunix: %s\n" "$socket"
701
702 MYSQL_SOCKET=$socket slave_status
703
704 progress "$MYSQL_STATUS"
705 else
706 show "MySQL cluster %s" "$mysqldir"
707 progress "$MYSQL_STATUS" "$CFAIL"
708 fi
709 echo
710 done
711 fi
712 ;;
713 *)
714 msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
715 exit 3
716esac
717
718exit $RETVAL
This page took 0.040185 seconds and 4 git commands to generate.